import 'dart:io';

import 'package:firebase_messaging/firebase_messaging.dart';

class PIA_FireBase_CallBack
{   FireBase_OnMessage(dynamic message){} }

class PIA_FireBase {
  static final FirebaseMessaging _firebaseMessaging = FirebaseMessaging();
  static List<PIA_FireBase_CallBack> callbacklist = List<PIA_FireBase_CallBack>();
  static String token = "";



  static void connect() {
  if (Platform.isIOS) iOS_Permission();

  _firebaseMessaging.getToken().then((token){
    print("Token :" + token);
    PIA_FireBase.token = token;
  });

  _firebaseMessaging.configure(
    onMessage: (Map<String, dynamic> message) async {
      print('FireBase on message $message');
      print(message["data"]["title"]);

      if(callbacklist.last != null)
         {  callbacklist.last.FireBase_OnMessage(message["data"]); }
    },
    onResume: (Map<String, dynamic> message) async {
      print('on resume $message');
    },
    onLaunch: (Map<String, dynamic> message) async {
      print('on launch $message');
    },
  );


}

static void set_topic(String topic)
{  _firebaseMessaging.subscribeToTopic('topic'); }


static void initState_CallBack(PIA_FireBase_CallBack callback)
{  callbacklist.add(callback); }


static void dispose(PIA_FireBase_CallBack callback)
 { callbacklist.remove(callback); }

static void iOS_Permission() {
  _firebaseMessaging.requestNotificationPermissions(
      IosNotificationSettings(sound: true, badge: true, alert: true)
  );
  _firebaseMessaging.onIosSettingsRegistered
      .listen((IosNotificationSettings settings)
  {
    print("Settings registered: $settings");
  });
}


}